Index: uspace/lib/ui/include/ui/filedialog.h
===================================================================
--- uspace/lib/ui/include/ui/filedialog.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/include/ui/filedialog.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,53 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file File dialog
+ */
+
+#ifndef _UI_FILEDIALOG_H
+#define _UI_FILEDIALOG_H
+
+#include <errno.h>
+#include <types/ui/filedialog.h>
+#include <types/ui/ui.h>
+
+extern void ui_file_dialog_params_init(ui_file_dialog_params_t *);
+extern errno_t ui_file_dialog_create(ui_t *, ui_file_dialog_params_t *,
+    ui_file_dialog_t **);
+extern void ui_file_dialog_set_cb(ui_file_dialog_t *, ui_file_dialog_cb_t *,
+    void *);
+extern void ui_file_dialog_destroy(ui_file_dialog_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/fixed.h
===================================================================
--- uspace/lib/ui/include/ui/fixed.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/include/ui/fixed.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -49,5 +49,7 @@
 extern void ui_fixed_remove(ui_fixed_t *, ui_control_t *);
 extern errno_t ui_fixed_paint(ui_fixed_t *);
+extern ui_evclaim_t ui_fixed_kbd_event(ui_fixed_t *, kbd_event_t *);
 extern ui_evclaim_t ui_fixed_pos_event(ui_fixed_t *, pos_event_t *);
+extern void ui_fixed_unfocus(ui_fixed_t *);
 
 #endif
Index: uspace/lib/ui/include/ui/menu.h
===================================================================
--- uspace/lib/ui/include/ui/menu.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/include/ui/menu.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu
+ */
+
+#ifndef _UI_MENU_H
+#define _UI_MENU_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <io/pos_event.h>
+#include <types/ui/menu.h>
+#include <types/ui/menubar.h>
+#include <types/ui/event.h>
+
+extern errno_t ui_menu_create(ui_menu_bar_t *, const char *, ui_menu_t **);
+extern void ui_menu_destroy(ui_menu_t *);
+extern ui_menu_t *ui_menu_first(ui_menu_bar_t *);
+extern ui_menu_t *ui_menu_next(ui_menu_t *);
+extern const char *ui_menu_caption(ui_menu_t *);
+extern void ui_menu_get_rect(ui_menu_t *, gfx_coord2_t *, gfx_rect_t *);
+extern errno_t ui_menu_open(ui_menu_t *, gfx_rect_t *);
+extern void ui_menu_close(ui_menu_t *);
+extern errno_t ui_menu_paint(ui_menu_t *, gfx_coord2_t *);
+extern ui_evclaim_t ui_menu_pos_event(ui_menu_t *, gfx_coord2_t *,
+    pos_event_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/menubar.h
===================================================================
--- uspace/lib/ui/include/ui/menubar.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/include/ui/menubar.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu bar
+ */
+
+#ifndef _UI_MENUBAR_H
+#define _UI_MENUBAR_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <io/pos_event.h>
+#include <types/ui/menubar.h>
+#include <types/ui/control.h>
+#include <types/ui/event.h>
+#include <types/ui/resource.h>
+#include <types/ui/ui.h>
+#include <types/ui/window.h>
+
+extern errno_t ui_menu_bar_create(ui_t *, ui_window_t *,
+    ui_menu_bar_t **);
+extern void ui_menu_bar_destroy(ui_menu_bar_t *);
+extern ui_control_t *ui_menu_bar_ctl(ui_menu_bar_t *);
+extern void ui_menu_bar_set_rect(ui_menu_bar_t *, gfx_rect_t *);
+extern errno_t ui_menu_bar_paint(ui_menu_bar_t *);
+extern ui_evclaim_t ui_menu_bar_pos_event(ui_menu_bar_t *, pos_event_t *);
+extern void ui_menu_bar_unfocus(ui_menu_bar_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/menuentry.h
===================================================================
--- uspace/lib/ui/include/ui/menuentry.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/include/ui/menuentry.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu entry
+ */
+
+#ifndef _UI_MENUENTRY_H
+#define _UI_MENUENTRY_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <types/ui/menu.h>
+#include <types/ui/menuentry.h>
+#include <types/ui/event.h>
+
+extern errno_t ui_menu_entry_create(ui_menu_t *, const char *, const char *,
+    ui_menu_entry_t **);
+extern errno_t ui_menu_entry_sep_create(ui_menu_t *, ui_menu_entry_t **);
+extern void ui_menu_entry_destroy(ui_menu_entry_t *);
+extern void ui_menu_entry_set_cb(ui_menu_entry_t *, ui_menu_entry_cb_t,
+    void *);
+extern ui_menu_entry_t *ui_menu_entry_first(ui_menu_t *);
+extern ui_menu_entry_t *ui_menu_entry_next(ui_menu_entry_t *);
+extern gfx_coord_t ui_menu_entry_calc_width(ui_menu_t *,
+    gfx_coord_t, gfx_coord_t);
+extern void ui_menu_entry_column_widths(ui_menu_entry_t *,
+    gfx_coord_t *, gfx_coord_t *);
+extern gfx_coord_t ui_menu_entry_height(ui_menu_entry_t *);
+extern errno_t ui_menu_entry_paint(ui_menu_entry_t *, gfx_coord2_t *);
+extern void ui_menu_entry_press(ui_menu_entry_t *, gfx_coord2_t *);
+extern void ui_menu_entry_release(ui_menu_entry_t *);
+extern void ui_menu_entry_enter(ui_menu_entry_t *, gfx_coord2_t *);
+extern void ui_menu_entry_leave(ui_menu_entry_t *, gfx_coord2_t *);
+extern ui_evclaim_t ui_menu_entry_pos_event(ui_menu_entry_t *, gfx_coord2_t *,
+    pos_event_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/msgdialog.h
===================================================================
--- uspace/lib/ui/include/ui/msgdialog.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/include/ui/msgdialog.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,53 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Message dialog
+ */
+
+#ifndef _UI_MSGDIALOG_H
+#define _UI_MSGDIALOG_H
+
+#include <errno.h>
+#include <types/ui/msgdialog.h>
+#include <types/ui/ui.h>
+
+extern void ui_msg_dialog_params_init(ui_msg_dialog_params_t *);
+extern errno_t ui_msg_dialog_create(ui_t *, ui_msg_dialog_params_t *,
+    ui_msg_dialog_t **);
+extern void ui_msg_dialog_set_cb(ui_msg_dialog_t *, ui_msg_dialog_cb_t *,
+    void *);
+extern void ui_msg_dialog_destroy(ui_msg_dialog_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/paint.h
===================================================================
--- uspace/lib/ui/include/ui/paint.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/include/ui/paint.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,7 +40,19 @@
 #include <gfx/color.h>
 #include <gfx/coord.h>
+#include <types/ui/paint.h>
+#include <types/ui/resource.h>
 
-errno_t ui_paint_bevel(gfx_context_t *, gfx_rect_t *, gfx_color_t *,
+extern errno_t ui_paint_bevel(gfx_context_t *, gfx_rect_t *, gfx_color_t *,
     gfx_color_t *, gfx_coord_t, gfx_rect_t *);
+extern void ui_paint_get_bevel_inside(gfx_context_t *, gfx_rect_t *,
+    gfx_coord_t, gfx_rect_t *);
+extern errno_t ui_paint_inset_frame(ui_resource_t *, gfx_rect_t *,
+    gfx_rect_t *);
+extern void ui_paint_get_inset_frame_inside(ui_resource_t *, gfx_rect_t *,
+    gfx_rect_t *);
+extern errno_t ui_paint_outset_frame(ui_resource_t *, gfx_rect_t *,
+    gfx_rect_t *);
+extern errno_t ui_paint_filled_circle(gfx_context_t *, gfx_coord2_t *,
+    gfx_coord_t, ui_fcircle_part_t);
 
 #endif
Index: uspace/lib/ui/include/ui/popup.h
===================================================================
--- uspace/lib/ui/include/ui/popup.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/include/ui/popup.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,60 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Popup window
+ */
+
+#ifndef _UI_POPUP_H
+#define _UI_POPUP_H
+
+#include <errno.h>
+#include <gfx/context.h>
+#include <types/ui/control.h>
+#include <types/ui/ui.h>
+#include <types/ui/popup.h>
+#include <types/ui/resource.h>
+#include <types/ui/window.h>
+
+extern void ui_popup_params_init(ui_popup_params_t *);
+extern errno_t ui_popup_create(ui_t *, ui_window_t *, ui_popup_params_t *,
+    ui_popup_t **);
+extern void ui_popup_set_cb(ui_popup_t *, ui_popup_cb_t *, void *);
+extern void ui_popup_destroy(ui_popup_t *);
+extern void ui_popup_add(ui_popup_t *, ui_control_t *);
+extern void ui_popup_remove(ui_popup_t *, ui_control_t *);
+extern ui_resource_t *ui_popup_get_res(ui_popup_t *);
+extern gfx_context_t *ui_popup_get_gc(ui_popup_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/rbutton.h
===================================================================
--- uspace/lib/ui/include/ui/rbutton.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/include/ui/rbutton.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,70 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Radio button
+ */
+
+#ifndef _UI_RBUTTON_H
+#define _UI_RBUTTON_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <io/pos_event.h>
+#include <types/ui/rbutton.h>
+#include <types/ui/control.h>
+#include <types/ui/event.h>
+#include <types/ui/resource.h>
+#include <stdbool.h>
+
+extern errno_t ui_rbutton_group_create(ui_resource_t *,
+    ui_rbutton_group_t **);
+extern void ui_rbutton_group_destroy(ui_rbutton_group_t *);
+extern errno_t ui_rbutton_create(ui_rbutton_group_t *, const char *, void *,
+    ui_rbutton_t **);
+extern void ui_rbutton_destroy(ui_rbutton_t *);
+extern ui_control_t *ui_rbutton_ctl(ui_rbutton_t *);
+extern void ui_rbutton_group_set_cb(ui_rbutton_group_t *, ui_rbutton_group_cb_t *,
+    void *);
+extern void ui_rbutton_set_rect(ui_rbutton_t *, gfx_rect_t *);
+extern errno_t ui_rbutton_paint(ui_rbutton_t *);
+extern void ui_rbutton_press(ui_rbutton_t *);
+extern void ui_rbutton_release(ui_rbutton_t *);
+extern void ui_rbutton_enter(ui_rbutton_t *);
+extern void ui_rbutton_leave(ui_rbutton_t *);
+extern void ui_rbutton_select(ui_rbutton_t *);
+extern void ui_rbutton_selected(ui_rbutton_t *);
+extern ui_evclaim_t ui_rbutton_pos_event(ui_rbutton_t *, pos_event_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/resource.h
===================================================================
--- uspace/lib/ui/include/ui/resource.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/include/ui/resource.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -39,8 +39,12 @@
 #include <errno.h>
 #include <gfx/context.h>
+#include <stdbool.h>
 #include <types/ui/resource.h>
 
-extern errno_t ui_resource_create(gfx_context_t *, ui_resource_t **);
+extern errno_t ui_resource_create(gfx_context_t *, bool, ui_resource_t **);
 extern void ui_resource_destroy(ui_resource_t *);
+extern void ui_resource_set_expose_cb(ui_resource_t *, ui_expose_cb_t,
+    void *);
+extern void ui_resource_expose(ui_resource_t *);
 
 #endif
Index: uspace/lib/ui/include/ui/slider.h
===================================================================
--- uspace/lib/ui/include/ui/slider.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/include/ui/slider.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,66 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Slider
+ */
+
+#ifndef _UI_SLIDER_H
+#define _UI_SLIDER_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <io/pos_event.h>
+#include <stdbool.h>
+#include <types/ui/control.h>
+#include <types/ui/event.h>
+#include <types/ui/resource.h>
+#include <types/ui/slider.h>
+
+extern errno_t ui_slider_create(ui_resource_t *, const char *,
+    ui_slider_t **);
+extern void ui_slider_destroy(ui_slider_t *);
+extern ui_control_t *ui_slider_ctl(ui_slider_t *);
+extern void ui_slider_set_cb(ui_slider_t *, ui_slider_cb_t *, void *);
+extern void ui_slider_set_rect(ui_slider_t *, gfx_rect_t *);
+extern errno_t ui_slider_paint(ui_slider_t *);
+extern errno_t ui_slider_btn_clear(ui_slider_t *);
+extern gfx_coord_t ui_slider_length(ui_slider_t *);
+extern void ui_slider_press(ui_slider_t *, gfx_coord2_t *);
+extern void ui_slider_release(ui_slider_t *, gfx_coord2_t *);
+extern void ui_slider_update(ui_slider_t *, gfx_coord2_t *);
+extern void ui_slider_moved(ui_slider_t *, gfx_coord_t);
+extern ui_evclaim_t ui_slider_pos_event(ui_slider_t *, pos_event_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/ui.h
===================================================================
--- uspace/lib/ui/include/ui/ui.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/include/ui/ui.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,11 +39,17 @@
 #include <display.h>
 #include <errno.h>
+#include <io/console.h>
+#include <stdbool.h>
 #include <types/ui/ui.h>
 
 extern errno_t ui_create(const char *, ui_t **);
+extern errno_t ui_create_cons(console_ctrl_t *, ui_t **);
 extern errno_t ui_create_disp(display_t *, ui_t **);
 extern void ui_destroy(ui_t *);
 extern void ui_quit(ui_t *);
 extern void ui_run(ui_t *);
+extern errno_t ui_paint(ui_t *);
+extern bool ui_is_textmode(ui_t *);
+extern bool ui_is_fullscreen(ui_t *);
 
 #endif
Index: uspace/lib/ui/include/ui/wdecor.h
===================================================================
--- uspace/lib/ui/include/ui/wdecor.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/include/ui/wdecor.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -41,4 +41,5 @@
 #include <io/pos_event.h>
 #include <stdbool.h>
+#include <types/ui/event.h>
 #include <types/ui/resource.h>
 #include <types/ui/wdecor.h>
@@ -51,5 +52,5 @@
 extern void ui_wdecor_set_active(ui_wdecor_t *, bool);
 extern errno_t ui_wdecor_paint(ui_wdecor_t *);
-extern void ui_wdecor_pos_event(ui_wdecor_t *, pos_event_t *);
+extern ui_evclaim_t ui_wdecor_pos_event(ui_wdecor_t *, pos_event_t *);
 extern void ui_wdecor_rect_from_app(ui_wdecor_style_t, gfx_rect_t *,
     gfx_rect_t *);
Index: uspace/lib/ui/include/ui/window.h
===================================================================
--- uspace/lib/ui/include/ui/window.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/include/ui/window.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,4 +40,5 @@
 #include <gfx/context.h>
 #include <gfx/coord.h>
+#include <io/kbd_event.h>
 #include <io/pos_event.h>
 #include <types/ui/control.h>
@@ -53,12 +54,17 @@
 extern void ui_window_add(ui_window_t *, ui_control_t *);
 extern void ui_window_remove(ui_window_t *, ui_control_t *);
+extern ui_window_t *ui_window_get_active(ui_t *);
 extern errno_t ui_window_resize(ui_window_t *, gfx_rect_t *);
 extern ui_resource_t *ui_window_get_res(ui_window_t *);
 extern gfx_context_t *ui_window_get_gc(ui_window_t *);
+extern errno_t ui_window_get_pos(ui_window_t *, gfx_coord2_t *);
 extern errno_t ui_window_get_app_gc(ui_window_t *, gfx_context_t **);
 extern void ui_window_get_app_rect(ui_window_t *, gfx_rect_t *);
+extern void ui_window_set_ctl_cursor(ui_window_t *, ui_stock_cursor_t);
 extern errno_t ui_window_paint(ui_window_t *);
+extern void ui_window_def_kbd(ui_window_t *, kbd_event_t *);
 extern errno_t ui_window_def_paint(ui_window_t *);
 extern void ui_window_def_pos(ui_window_t *, pos_event_t *);
+extern void ui_window_def_unfocus(ui_window_t *);
 
 #endif
Index: uspace/lib/ui/meson.build
===================================================================
--- uspace/lib/ui/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2020 Jiri Svoboda
+# Copyright (c) 2021 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,15 +27,24 @@
 #
 
-deps = [ 'gfx', 'gfxfont', 'memgfx', 'display' ]
+deps = [ 'gfx', 'gfxfont', 'memgfx', 'display', 'congfx' ]
 src = files(
+	'src/checkbox.c',
 	'src/control.c',
 	'src/dummygc.c',
 	'src/entry.c',
+	'src/filedialog.c',
 	'src/fixed.c',
 	'src/image.c',
 	'src/label.c',
+	'src/menu.c',
+	'src/menubar.c',
+	'src/menuentry.c',
+	'src/msgdialog.c',
 	'src/paint.c',
 	'src/pbutton.c',
+	'src/popup.c',
+	'src/rbutton.c',
 	'src/resource.c',
+	'src/slider.c',
 	'src/ui.c',
 	'src/wdecor.c',
@@ -44,13 +53,22 @@
 
 test_src = files(
+	'test/checkbox.c',
 	'test/control.c',
 	'test/entry.c',
+	'test/filedialog.c',
 	'test/fixed.c',
 	'test/image.c',
 	'test/label.c',
 	'test/main.c',
+	'test/menu.c',
+	'test/menubar.c',
+	'test/menuentry.c',
+	'test/msgdialog.c',
 	'test/paint.c',
 	'test/pbutton.c',
+	'test/popup.c',
+	'test/rbutton.c',
 	'test/resource.c',
+	'test/slider.c',
 	'test/ui.c',
 	'test/wdecor.c',
Index: uspace/lib/ui/private/checkbox.h
===================================================================
--- uspace/lib/ui/private/checkbox.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/private/checkbox.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,71 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Check box structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_CHECKBOX_H
+#define _UI_PRIVATE_CHECKBOX_H
+
+#include <gfx/coord.h>
+#include <stdbool.h>
+
+/** Actual structure of check box.
+ *
+ * This is private to libui.
+ */
+struct ui_checkbox {
+	/** Base control object */
+	struct ui_control *control;
+	/** UI resource */
+	struct ui_resource *res;
+	/** Callbacks */
+	struct ui_checkbox_cb *cb;
+	/** Callback argument */
+	void *arg;
+	/** Check box rectangle */
+	gfx_rect_t rect;
+	/** Caption */
+	const char *caption;
+	/** Check box is checked */
+	bool checked;
+	/** Check box is currently held down */
+	bool held;
+	/** Pointer is currently inside */
+	bool inside;
+};
+
+#endif
+
+/** @}
+ */
